Index: /branches/Collections/sources/HeuristicLab.CEDMA.Core/AgentList.cs
===================================================================
--- /branches/Collections/sources/HeuristicLab.CEDMA.Core/AgentList.cs	(revision 383)
+++ /branches/Collections/sources/HeuristicLab.CEDMA.Core/AgentList.cs	(revision 384)
@@ -33,5 +33,4 @@
 namespace HeuristicLab.CEDMA.Core {
   public class AgentList : ItemBase, IAgentList {
-    private string serverUri;
     private List<IAgent> agentList;
     private IDatabase database;
Index: /branches/Collections/sources/HeuristicLab.CEDMA.Core/AgentListView.cs
===================================================================
--- /branches/Collections/sources/HeuristicLab.CEDMA.Core/AgentListView.cs	(revision 383)
+++ /branches/Collections/sources/HeuristicLab.CEDMA.Core/AgentListView.cs	(revision 384)
@@ -31,6 +31,4 @@
 namespace HeuristicLab.CEDMA.Core {
   public partial class AgentListView : ViewBase {
-    private ChooseItemDialog chooseItemDialog;
-
     public IAgentList AgentList {
       get { return (IAgentList)Item; }
Index: /branches/Collections/sources/HeuristicLab.CEDMA.Core/Console.cs
===================================================================
--- /branches/Collections/sources/HeuristicLab.CEDMA.Core/Console.cs	(revision 383)
+++ /branches/Collections/sources/HeuristicLab.CEDMA.Core/Console.cs	(revision 384)
@@ -53,5 +53,5 @@
     }
 
-    public IView CreateView() {
+    public override IView CreateView() {
       return new ConsoleEditor(this);
     }
Index: /branches/Collections/sources/HeuristicLab.CEDMA.Core/HeuristicLab.CEDMA.Core.csproj
===================================================================
--- /branches/Collections/sources/HeuristicLab.CEDMA.Core/HeuristicLab.CEDMA.Core.csproj	(revision 383)
+++ /branches/Collections/sources/HeuristicLab.CEDMA.Core/HeuristicLab.CEDMA.Core.csproj	(revision 384)
@@ -34,8 +34,4 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="HeuristicLab.PluginInfrastructure, Version=3.0.0.316, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\..\..\Program Files\HeuristicLab 3.0\HeuristicLab.PluginInfrastructure.dll</HintPath>
-    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core">
@@ -97,4 +93,8 @@
       <Name>HeuristicLab.Core</Name>
     </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
   </ItemGroup>
   <ItemGroup>
Index: /branches/Collections/sources/HeuristicLab.CEDMA.Core/IAgent.cs
===================================================================
--- /branches/Collections/sources/HeuristicLab.CEDMA.Core/IAgent.cs	(revision 383)
+++ /branches/Collections/sources/HeuristicLab.CEDMA.Core/IAgent.cs	(revision 384)
@@ -32,5 +32,4 @@
     ProcessStatus Status { get; }
     IOperatorGraph OperatorGraph { get; }
-    void Save();
     void Activate();
   }
Index: /branches/Collections/sources/HeuristicLab.CEDMA.DB.Interfaces/HeuristicLab.CEDMA.DB.Interfaces.csproj
===================================================================
--- /branches/Collections/sources/HeuristicLab.CEDMA.DB.Interfaces/HeuristicLab.CEDMA.DB.Interfaces.csproj	(revision 383)
+++ /branches/Collections/sources/HeuristicLab.CEDMA.DB.Interfaces/HeuristicLab.CEDMA.DB.Interfaces.csproj	(revision 384)
@@ -34,8 +34,4 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="HeuristicLab.PluginInfrastructure, Version=3.0.0.316, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\..\..\Program Files\HeuristicLab 3.0\HeuristicLab.PluginInfrastructure.dll</HintPath>
-    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core">
@@ -69,4 +65,10 @@
     <None Include="HeuristicLab.snk" />
   </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
+  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: /branches/Collections/sources/HeuristicLab.CEDMA.DB/HeuristicLab.CEDMA.DB.csproj
===================================================================
--- /branches/Collections/sources/HeuristicLab.CEDMA.DB/HeuristicLab.CEDMA.DB.csproj	(revision 383)
+++ /branches/Collections/sources/HeuristicLab.CEDMA.DB/HeuristicLab.CEDMA.DB.csproj	(revision 384)
@@ -36,8 +36,4 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="HeuristicLab.PluginInfrastructure, Version=3.0.0.316, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\..\..\Program Files\HeuristicLab 3.0\HeuristicLab.PluginInfrastructure.dll</HintPath>
-    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core">
@@ -76,4 +72,8 @@
       <Name>HeuristicLab.CEDMA.DB.Interfaces</Name>
     </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
     <ProjectReference Include="..\HeuristicLab.SQLite\HeuristicLab.SQLite.csproj">
       <Project>{6960CBCD-E44B-49B0-BA86-671091C42C36}</Project>
Index: /branches/Collections/sources/HeuristicLab.CEDMA.Operators/HeuristicLab.CEDMA.Operators.csproj
===================================================================
--- /branches/Collections/sources/HeuristicLab.CEDMA.Operators/HeuristicLab.CEDMA.Operators.csproj	(revision 383)
+++ /branches/Collections/sources/HeuristicLab.CEDMA.Operators/HeuristicLab.CEDMA.Operators.csproj	(revision 384)
@@ -34,8 +34,4 @@
   </PropertyGroup>
   <ItemGroup>
-    <Reference Include="HeuristicLab.PluginInfrastructure, Version=3.0.0.316, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
-      <SpecificVersion>False</SpecificVersion>
-      <HintPath>..\..\..\..\..\..\..\Program Files\HeuristicLab 3.0\HeuristicLab.PluginInfrastructure.dll</HintPath>
-    </Reference>
     <Reference Include="System" />
     <Reference Include="System.Core">
@@ -82,4 +78,8 @@
       <Name>HeuristicLab.Data</Name>
     </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /branches/Collections/sources/HeuristicLab.DistributedEngine/DistributedEngine.cs
===================================================================
--- /branches/Collections/sources/HeuristicLab.DistributedEngine/DistributedEngine.cs	(revision 383)
+++ /branches/Collections/sources/HeuristicLab.DistributedEngine/DistributedEngine.cs	(revision 384)
@@ -37,5 +37,4 @@
   public class DistributedEngine : EngineBase, IEditable {
     private JobManager jobManager;
-    private CompositeOperation waitingOperations;
     private string serverAddress;
     public string ServerAddress {
Index: /branches/Collections/sources/HeuristicLab.Grid/ClientForm.cs
===================================================================
--- /branches/Collections/sources/HeuristicLab.Grid/ClientForm.cs	(revision 383)
+++ /branches/Collections/sources/HeuristicLab.Grid/ClientForm.cs	(revision 384)
@@ -111,5 +111,5 @@
         try {
           gotEngine = engineStore.TryTakeEngine(out currentGuid, out engineXml);
-        } catch(TimeoutException timeoutException) {
+        } catch(TimeoutException) {
           currentEngine = null;
           currentGuid = Guid.Empty;
@@ -117,5 +117,5 @@
           fetchOperationTimer.Interval = 5000;
           fetchOperationTimer.Start();
-        } catch(CommunicationException communicationException) {
+        } catch(CommunicationException) {
           // connection problem -> reset connection and start the timer again
           ResetConnection();
@@ -155,9 +155,9 @@
               engineStore.StoreResult(currentGuid, resultXml);
               success = true;
-            } catch(TimeoutException timeoutException) {
+            } catch(TimeoutException) {
               success = false;
               retries++;
               Thread.Sleep(TimeSpan.FromSeconds(CONNECTION_RETRY_TIMEOUT_SEC));
-            } catch(CommunicationException communicationException) {
+            } catch(CommunicationException) {
               ResetConnection();
               success = false;
Index: /branches/Collections/sources/HeuristicLab.Grid/JobManager.cs
===================================================================
--- /branches/Collections/sources/HeuristicLab.Grid/JobManager.cs	(revision 383)
+++ /branches/Collections/sources/HeuristicLab.Grid/JobManager.cs	(revision 384)
@@ -189,8 +189,8 @@
           }
           return;
-        } catch(TimeoutException timeoutException) {
-          retries++;
-          Thread.Sleep(TimeSpan.FromSeconds(RETRY_TIMEOUT_SEC));
-        } catch(CommunicationException communicationException) {
+        } catch(TimeoutException) {
+          retries++;
+          Thread.Sleep(TimeSpan.FromSeconds(RETRY_TIMEOUT_SEC));
+        } catch(CommunicationException) {
           ResetConnection();
           retries++;
@@ -208,8 +208,8 @@
             return zippedResult;
           }
-        } catch(TimeoutException timeoutException) {
-          retries++;
-          Thread.Sleep(TimeSpan.FromSeconds(RETRY_TIMEOUT_SEC));
-        } catch(CommunicationException communicationException) {
+        } catch(TimeoutException) {
+          retries++;
+          Thread.Sleep(TimeSpan.FromSeconds(RETRY_TIMEOUT_SEC));
+        } catch(CommunicationException) {
           ResetConnection();
           retries++;
@@ -229,8 +229,8 @@
             return jobState;
           }
-        } catch(TimeoutException timeoutException) {
-          retries++;
-          Thread.Sleep(TimeSpan.FromSeconds(RETRY_TIMEOUT_SEC));
-        } catch(CommunicationException communicationException) {
+        } catch(TimeoutException) {
+          retries++;
+          Thread.Sleep(TimeSpan.FromSeconds(RETRY_TIMEOUT_SEC));
+        } catch(CommunicationException) {
           ResetConnection();
           retries++;
Index: /branches/Collections/sources/HeuristicLab.Grid/ProcessingEngine.cs
===================================================================
--- /branches/Collections/sources/HeuristicLab.Grid/ProcessingEngine.cs	(revision 383)
+++ /branches/Collections/sources/HeuristicLab.Grid/ProcessingEngine.cs	(revision 384)
@@ -63,5 +63,5 @@
         try {
           next = atomicOperation.Operator.Execute(atomicOperation.Scope);
-        } catch(Exception ex) {
+        } catch(Exception) {
           // push operation on stack again
           myExecutionStack.Push(atomicOperation);
Index: /branches/Collections/sources/HeuristicLab.PluginInfrastructure.GUI/PluginAction.cs
===================================================================
--- /branches/Collections/sources/HeuristicLab.PluginInfrastructure.GUI/PluginAction.cs	(revision 383)
+++ /branches/Collections/sources/HeuristicLab.PluginInfrastructure.GUI/PluginAction.cs	(revision 384)
@@ -65,5 +65,4 @@
           // this method is not defined for actions other than "Install" and "Remove"
           throw new InvalidOperationException();
-          return "";
       }
     }
Index: /branches/Collections/sources/HeuristicLab.PluginInfrastructure/Loader.cs
===================================================================
--- /branches/Collections/sources/HeuristicLab.PluginInfrastructure/Loader.cs	(revision 383)
+++ /branches/Collections/sources/HeuristicLab.PluginInfrastructure/Loader.cs	(revision 384)
@@ -95,5 +95,5 @@
         try {
           return Assembly.ReflectionOnlyLoad(args.Name);
-        } catch(FileLoadException ex) {
+        } catch(FileLoadException) {
           return null;
         }